from typing import cast as __cast

from ._binaryen import lib as __lib
from .internals import BinaryenExpressionId as __BinaryenExpressionId

InvalidId = __cast(__BinaryenExpressionId, __lib.BinaryenInvalidId())
NopId = __cast(__BinaryenExpressionId, __lib.BinaryenNopId())
BlockId = __cast(__BinaryenExpressionId, __lib.BinaryenBlockId())
IfId = __cast(__BinaryenExpressionId, __lib.BinaryenIfId())
LoopId = __cast(__BinaryenExpressionId, __lib.BinaryenLoopId())
BreakId = __cast(__BinaryenExpressionId, __lib.BinaryenBreakId())
SwitchId = __cast(__BinaryenExpressionId, __lib.BinaryenSwitchId())
CallId = __cast(__BinaryenExpressionId, __lib.BinaryenCallId())
CallIndirectId = __cast(__BinaryenExpressionId, __lib.BinaryenCallIndirectId())
LocalGetId = __cast(__BinaryenExpressionId, __lib.BinaryenLocalGetId())
LocalSetId = __cast(__BinaryenExpressionId, __lib.BinaryenLocalSetId())
GlobalGetId = __cast(__BinaryenExpressionId, __lib.BinaryenGlobalGetId())
GlobalSetId = __cast(__BinaryenExpressionId, __lib.BinaryenGlobalSetId())
LoadId = __cast(__BinaryenExpressionId, __lib.BinaryenLoadId())
StoreId = __cast(__BinaryenExpressionId, __lib.BinaryenStoreId())
AtomicRMWId = __cast(__BinaryenExpressionId, __lib.BinaryenAtomicRMWId())
AtomicCmpxchgId = __cast(__BinaryenExpressionId, __lib.BinaryenAtomicCmpxchgId())
AtomicWaitId = __cast(__BinaryenExpressionId, __lib.BinaryenAtomicWaitId())
AtomicNotifyId = __cast(__BinaryenExpressionId, __lib.BinaryenAtomicNotifyId())
AtomicFenceId = __cast(__BinaryenExpressionId, __lib.BinaryenAtomicFenceId())
SIMDExtractId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDExtractId())
SIMDReplaceId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDReplaceId())
SIMDShuffleId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDShuffleId())
SIMDTernaryId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDTernaryId())
SIMDShiftId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDShiftId())
SIMDLoadId = __cast(__BinaryenExpressionId, __lib.BinaryenSIMDLoadId())
SIMDLoadStoreLaneId = __cast(
    __BinaryenExpressionId, __lib.BinaryenSIMDLoadStoreLaneId()
)
MemoryInitId = __cast(__BinaryenExpressionId, __lib.BinaryenMemoryInitId())
DataDropId = __cast(__BinaryenExpressionId, __lib.BinaryenDataDropId())
MemoryCopyId = __cast(__BinaryenExpressionId, __lib.BinaryenMemoryCopyId())
MemoryFillId = __cast(__BinaryenExpressionId, __lib.BinaryenMemoryFillId())
ConstId = __cast(__BinaryenExpressionId, __lib.BinaryenConstId())
UnaryId = __cast(__BinaryenExpressionId, __lib.BinaryenUnaryId())
BinaryId = __cast(__BinaryenExpressionId, __lib.BinaryenBinaryId())
SelectId = __cast(__BinaryenExpressionId, __lib.BinaryenSelectId())
DropId = __cast(__BinaryenExpressionId, __lib.BinaryenDropId())
ReturnId = __cast(__BinaryenExpressionId, __lib.BinaryenReturnId())
MemorySizeId = __cast(__BinaryenExpressionId, __lib.BinaryenMemorySizeId())
MemoryGrowId = __cast(__BinaryenExpressionId, __lib.BinaryenMemoryGrowId())
UnreachableId = __cast(__BinaryenExpressionId, __lib.BinaryenUnreachableId())
PopId = __cast(__BinaryenExpressionId, __lib.BinaryenPopId())
RefNullId = __cast(__BinaryenExpressionId, __lib.BinaryenRefNullId())
RefIsNullId = __cast(__BinaryenExpressionId, __lib.BinaryenRefIsNullId())
RefFuncId = __cast(__BinaryenExpressionId, __lib.BinaryenRefFuncId())
RefEqId = __cast(__BinaryenExpressionId, __lib.BinaryenRefEqId())
TableGetId = __cast(__BinaryenExpressionId, __lib.BinaryenTableGetId())
TableSetId = __cast(__BinaryenExpressionId, __lib.BinaryenTableSetId())
TableSizeId = __cast(__BinaryenExpressionId, __lib.BinaryenTableSizeId())
TableGrowId = __cast(__BinaryenExpressionId, __lib.BinaryenTableGrowId())
TableFillId = __cast(__BinaryenExpressionId, __lib.BinaryenTableFillId())
TableCopyId = __cast(__BinaryenExpressionId, __lib.BinaryenTableCopyId())
TryId = __cast(__BinaryenExpressionId, __lib.BinaryenTryId())
TryTableId = __cast(__BinaryenExpressionId, __lib.BinaryenTryTableId())
ThrowId = __cast(__BinaryenExpressionId, __lib.BinaryenThrowId())
RethrowId = __cast(__BinaryenExpressionId, __lib.BinaryenRethrowId())
ThrowRefId = __cast(__BinaryenExpressionId, __lib.BinaryenThrowRefId())
TupleMakeId = __cast(__BinaryenExpressionId, __lib.BinaryenTupleMakeId())
TupleExtractId = __cast(__BinaryenExpressionId, __lib.BinaryenTupleExtractId())
RefI31Id = __cast(__BinaryenExpressionId, __lib.BinaryenRefI31Id())
I31GetId = __cast(__BinaryenExpressionId, __lib.BinaryenI31GetId())
CallRefId = __cast(__BinaryenExpressionId, __lib.BinaryenCallRefId())
RefTestId = __cast(__BinaryenExpressionId, __lib.BinaryenRefTestId())
RefCastId = __cast(__BinaryenExpressionId, __lib.BinaryenRefCastId())
BrOnId = __cast(__BinaryenExpressionId, __lib.BinaryenBrOnId())
StructNewId = __cast(__BinaryenExpressionId, __lib.BinaryenStructNewId())
StructGetId = __cast(__BinaryenExpressionId, __lib.BinaryenStructGetId())
StructSetId = __cast(__BinaryenExpressionId, __lib.BinaryenStructSetId())
ArrayNewId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayNewId())
ArrayNewDataId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayNewDataId())
ArrayNewElemId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayNewElemId())
ArrayNewFixedId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayNewFixedId())
ArrayGetId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayGetId())
ArraySetId = __cast(__BinaryenExpressionId, __lib.BinaryenArraySetId())
ArrayLenId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayLenId())
ArrayCopyId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayCopyId())
ArrayFillId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayFillId())
ArrayInitDataId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayInitDataId())
ArrayInitElemId = __cast(__BinaryenExpressionId, __lib.BinaryenArrayInitElemId())
RefAsId = __cast(__BinaryenExpressionId, __lib.BinaryenRefAsId())
StringNewId = __cast(__BinaryenExpressionId, __lib.BinaryenStringNewId())
StringConstId = __cast(__BinaryenExpressionId, __lib.BinaryenStringConstId())
StringMeasureId = __cast(__BinaryenExpressionId, __lib.BinaryenStringMeasureId())
StringEncodeId = __cast(__BinaryenExpressionId, __lib.BinaryenStringEncodeId())
StringConcatId = __cast(__BinaryenExpressionId, __lib.BinaryenStringConcatId())
StringEqId = __cast(__BinaryenExpressionId, __lib.BinaryenStringEqId())
StringAsId = __cast(__BinaryenExpressionId, __lib.BinaryenStringAsId())
StringWTF8AdvanceId = __cast(
    __BinaryenExpressionId, __lib.BinaryenStringWTF8AdvanceId()
)
StringWTF16GetId = __cast(__BinaryenExpressionId, __lib.BinaryenStringWTF16GetId())
StringIterNextId = __cast(__BinaryenExpressionId, __lib.BinaryenStringIterNextId())
StringIterMoveId = __cast(__BinaryenExpressionId, __lib.BinaryenStringIterMoveId())
StringSliceWTFId = __cast(__BinaryenExpressionId, __lib.BinaryenStringSliceWTFId())
StringSliceIterId = __cast(__BinaryenExpressionId, __lib.BinaryenStringSliceIterId())
ContNewId = __cast(__BinaryenExpressionId, __lib.BinaryenContNewId())
ResumeId = __cast(__BinaryenExpressionId, __lib.BinaryenResumeId())
